
var placeSearch, autocomplete, autocomplete2;

function fillInAddress(autoObj, addrID, suburbID, cityID, postcodeID){
  
  var place = autoObj.getPlace();
  
  $('.address_field').val('');
  var sub_locale = false;
  
  var street_number = '';
  var route = '';
  var sublocality_level_1 = '';
  var locality = '';
  var postal_town = '';
  var administrative_area_level_1 = '';
  var administrative_area_level_2 = '';
  var postal_code = '';
  var country = '';
  
  for (var i = 0; i < place.address_components.length; i++) {
    
    var addressType = place.address_components[i].types[0];
    var addressVal  = place.address_components[i]['long_name'];
    
    if (addressType == 'street_number') { street_number = addressVal; }
    if (addressType == 'route') { route = addressVal; }
    if (addressType == 'sublocality_level_1') { sublocality_level_1 = addressVal; }
    if (addressType == 'locality') { locality = addressVal; }
    if (addressType == 'postal_town') { postal_town = addressVal; }
    if (addressType == 'administrative_area_level_1') { administrative_area_level_1 = addressVal; }
    if (addressType == 'administrative_area_level_2') { administrative_area_level_2 = addressVal; }
    if (addressType == 'postal_code') { postal_code = addressVal; }
    if (addressType == 'country') { country = addressVal; }
    
  }
  
  // Field 1
  if ( street_number.length > 0 ) { $('#' + addrID).val( street_number ); }
  if ( route.length > 0 ) { $('#' + addrID).val( street_number + ' ' + route ); }
  
  // Field 2
  if ( sublocality_level_1.length > 0 ) { $('#' + suburbID).val( sublocality_level_1 ); }
  if ( sublocality_level_1.length == 0 && locality.length > 0 ) {
    $('#' + suburbID).val( locality ); 
  }
  
  // Field 3
  if ( postal_town.length > 0 ) {
    $('#' + cityID).val(postal_town);
    
  } else if ( locality.length > 0 && $('#' + suburbID).val() != locality ) {
    $('#' + cityID).val(locality);
    
  } else {
    $('#' + cityID).val(administrative_area_level_1);
    
  }
  
  // Field 4
  if ( postal_code.length > 0 ) { $('#' + postcodeID).val(postal_code); }
  
}


function showLoading() {

  $("#loading").remove();
  var template = '<div class="box-loadong" id="loading">\
                    <div class="b b1"></div>\
                    <div class="b b2"></div>\
                    <div class="b b3"></div>\
                    <div class="b b4"></div>\
                  </div>';
  $('body').append(template);
  
}

function removeLoading() {
  if ($("#loading").length) {
    $("#loading").fadeOut();
    setTimeout(function(){
      $("#loading").remove();
    },300)
  }
}



function basicFormAjaxSubmit( url, formData, callBack ){
  
  $('.highlight-form-field').removeClass('highlight-form-field');
  $('.highlight-form-label').removeClass('highlight-form-label');
  //showLoading();

  $.ajax({
    
    type: "POST",
    data: formData,
    url: url,
    dataType: "JSON",
    contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
    processData: true,
    complete: function(data) {
      
      if ( data.responseJSON ){
        var response = data.responseJSON;
      } else {
        var response = JSON.parse( data.responseText );
      }

          
      if (response.status == 'success') {

        if (response.redirect) {
          actionRedirect(response);
        } else {
          $('#systemMessage').addClass('success');
          callBack( response );
          removeLoading();
        }
        
      } else if ( response.status == 'fail' ) {
        removeLoading();
        for (var key in response.fields){
          
          if ($('input[name="' + key + '"]').length > 0){
            var field = $('input[name="' + key + '"]');
            
            if ( field.attr('type') == "checkbox" || field.attr('type') == "radio" ){
              field.parent().addClass('highlight-form-label');
              field.addClass('highlight-form-field');
              
            } else {
              field.addClass('highlight-form-field');
            }
            
          } else if ($('textarea[name="' + key + '"]').length > 0){
            var field = $('textarea[name="' + key + '"]');
            field.addClass('highlight-form-field');
            
          } else if ($('select[name="' + key + '"]').length > 0){
            var field = $('select[name="' + key + '"]');
            field.addClass('highlight-form-field');
            
          }
        }
      }
      
      if (response.message){
        if (response.formtype == 'Newsletters') {
          $('#'+response.src+'Message').html(response.message);
          $('#'+response.src+'Message').addClass('highlight_message');
          if (response.status == 'success') {
            $('#'+response.src+'Message').addClass('success');
          }
        } else { 
          $('#systemMessage').html(response.message);
          $('#systemMessage').addClass('highlight_message');
          $('html,body').animate({scrollTop: $("#scrollPoint").offset().top},'slow');
        }
      }
      
      return response;
    }
  });
}

function updateMyCartTotals( response ){
  if ( response.myCart ){ $('#myCart').html( response.myCart ); }
  return false;
}

function updateCartTotals( response ){
  if ( response.myCart ){ $('#myCart').html( response.myCart ); }
  if ( response.sub_total ){ $('#cartSubTotal').html( response.sub_total ); }
  if ( response.total ){ $('#cartTotal').html( response.total + ' NZD' ); }
  if ( response.total_products == 0 ){ $("#cartContainer").html( '' ); }
  if ( response.product_action == 'update' ){
    $('#product_total_' + response.product).html( response.product_total );
  } else if ( response.product_action == 'delete' ){
    $("#quantity_" + response.product).parent().parent().remove();
  }
  return false;
}

function checkoutResponse( response ){
  if ( response.redirect ){ location.href = response.redirect; }
  return false;
}

function accountLogin( response ){
  if ( response.redirect ){ location.href = response.redirect; }
  return false;
}


function accountForm( response ){
  if ( response.redirect ){ location.href = response.redirect; }
  return false;
}


function accountPasswordReset( response ){
  //if ( response.redirect ){ location.href = response.redirect; }
  return false;
}

function actionNone( response ){
  
  return false;
}

function actionRedirect( response ){
  if ( response.redirect ){ location.href = response.redirect; }
  return false;
}

function validate() {

  var error = false;

  $('#systemMessage').html('');
  $('#systemMessage').removeClass('highlight_message');

  $('.highlight-form-field').removeClass('highlight-form-field');
  $("#form_donation .mandatory").each(function() {
    var fields = $(this);
    if (!fields.val()) {
      fields.addClass('highlight-form-field');
      error = true;
    }
  });

  if (error) {
    $('#systemMessage').html("Please fill the highlight fields.");
    $('#systemMessage').addClass('highlight_message');
    $('html,body').animate({scrollTop: $("#scrollPoint").offset().top},'slow');
  }

  return error;
}


function AjaxFileUploadSubmit( url, formData, callBack ){
  
  $('.highlight-form-field').removeClass('highlight-form-field');
  $('.highlight-form-label').removeClass('highlight-form-label');
  
  $.ajax({
    type: "POST",
    data: formData,
    url: url,
    dataType: "JSON",
    contentType: false,
    processData: false,
    complete: function(data){
      
      if ( data.responseJSON ){
        var response = data.responseJSON;
      } else {
        var response = JSON.parse( data.responseText );
      }
      
      
      
      if (response.status == 'success'){
        callBack( response );
        
      } else if ( response.status == 'fail' ){
        for (var key in response.fields){
          
          if ($('input[name="' + key + '"]').length > 0){
            var field = $('input[name="' + key + '"]');
            
            if ( field.attr('type') == "checkbox" ){
              field.parent().find('label').addClass('highlight-form-label');
              
            } else {
              field.addClass('highlight-form-field');
            }
            
          } else if ($('textarea[name="' + key + '"]').length > 0){
            var field = $('textarea[name="' + key + '"]');
            field.addClass('highlight-form-field');
            
          } else if ($('select[name="' + key + '"]').length > 0){
            var field = $('select[name="' + key + '"]');
            field.addClass('highlight-form-field');
            
          }
        }
      }
      
      if (response.message){
        $('#systemMessage').html(response.message);
        $('#systemMessage').addClass('highlight_message');
        $('html,body').animate({scrollTop: $("#scrollPoint").offset().top},'slow');
      }
      
      return response;
    }
  });
}


/**************** Create Modal Box *************************************/
function showModal(title,message) {
  const details = {title: title,
                  message: message };
  $('body').append(createModal(details));
}

function createModal(details) {
  const template = '<div id="modal-content">\
                      <div class="modal-content white-content show">\
                        <div class="image-modal">\
                          <div class="loading-icon">\
                            <div class="icon"></div>\
                          </div>\
                        </div>\
                        <div class="title">'+details.title+'</div>\
                        <p class="message-modal">'+details.message+'</p>\
                        <div class="flex" id="model-buttons">\
                        </div>\
                      </div>\
                      <div class="modal-background show"></div>\
                    </div>';
  return template;
}

/* Close/Destroy modal */
function closeModal() {
  $("#modal-content").fadeOut('slow');
  setTimeout(function() {
    $("#modal-content").remove();
  },200);
}

function updateModal(title,message) {
  $("#modal-content .title").html(title);
  $("#modal-content .message-modal").html(message);
}
